SystemOrganization addCategory: #'Path-Spike-Record-Replay'!
SystemOrganization addCategory: #'Path-Spike-StateView'!

MwMethodWrapper subclass: #SRecordReplayWrapper
	instanceVariableNames: 'replayCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Spike-Record-Replay'!

!SRecordReplayWrapper class methodsFor: 'instance creation' stamp: 'mp 5/18/2010 11:36'!
on: aSymbol inClass: aClass with: aReplayCache
	
	^ (self on: aSymbol inClass: aClass)
		replayCache: aReplayCache;
		yourself! !

!SRecordReplayWrapper methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:36'!
replayCache
	"Answer the value of replayCache"

	^ replayCache! !

!SRecordReplayWrapper methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:36'!
replayCache: anObject
	"Set the value of replayCache"

	replayCache := anObject! !

!SRecordReplayWrapper methodsFor: 'evaluating' stamp: 'mp 5/18/2010 11:41'!
valueWithReceiver: anObject arguments: anArrayOfObjects
	| record result |
	record := self replayCache 
		at: (MethodReference class: self wrappedClass selector: self clientSelector) 
		receiver: anObject 
		arguments: anArrayOfObjects.
	record ifNotNil: [^ record recordedResult].
	self beforeMethod.
	^ [	result := self clientMethod valueWithReceiver: anObject arguments: anArrayOfObjects.
		self replayCache 
			at: (MethodReference class: self wrappedClass selector: self clientSelector) 
			receiver: anObject 
			arguments: anArrayOfObjects
			put: result.
		result
	] ensure: [self afterMethod]! !

Object subclass: #SReplayCache
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Spike-Record-Replay'!

!SReplayCache methodsFor: 'public API' stamp: 'mp 7/7/2010 16:58:15.942'!
at: aMethodReference receiver: anObject arguments: aCollection
	| record |
	record := self cache 
				at: (SReplayRecord method: aMethodReference receiver: anObject arguments: aCollection) 
				ifAbsent: [nil].
	record ifNotNil: [
		(record receiver = anObject and: [record arguments = aCollection])
			ifFalse: [record := nil]
		].
	^ record! !

!SReplayCache methodsFor: 'public API' stamp: 'mp 7/7/2010 16:58:19.13'!
at: aMethodReference receiver: anObject arguments: aCollection put: aResult
	| record |
	self flag: #mpe. "Refactor me!!!!!!"
	record := SReplayRecord method: aMethodReference receiver: anObject arguments: aCollection result: aResult.
	self cache 
		at: record 
		put: record.
	! !

!SReplayCache methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:24'!
cache
	"Answer the value of cache"

	^ cache! !

!SReplayCache methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:24'!
cache: anObject
	"Set the value of cache"

	cache := anObject! !

!SReplayCache methodsFor: 'initialize-release' stamp: 'mp 5/18/2010 11:24'!
initialize

	self cache: Dictionary new.! !

Object subclass: #SReplayRecord
	instanceVariableNames: 'methodReference receiver arguments recordedResult'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Spike-Record-Replay'!

!SReplayRecord class methodsFor: 'instance creation' stamp: 'mp 5/18/2010 12:02'!
method: aMethodReference receiver: anObject arguments: aCollection

	^ self new
		methodReference: aMethodReference;
		receiver: anObject;
		arguments: aCollection;
		yourself! !

!SReplayRecord class methodsFor: 'instance creation' stamp: 'mp 5/18/2010 11:54'!
method: aMethodReference receiver: anObject arguments: aCollection result: aResult

	^ self new
		methodReference: aMethodReference;
		receiver: anObject;
		arguments: aCollection;
		recordedResult: aResult;
		yourself! !

!SReplayRecord methodsFor: 'comparing' stamp: 'mp 5/18/2010 11:58'!
= anObject

	self class == anObject class ifFalse: [^ false].
	^ ((anObject methodReference = self methodReference) 
		and: 	[anObject receiver = self receiver]) 
		and: [anObject arguments = self arguments]! !

!SReplayRecord methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:23'!
arguments
	"Answer the value of arguments"

	^ arguments! !

!SReplayRecord methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:23'!
arguments: anObject
	"Set the value of arguments"

	arguments := anObject! !

!SReplayRecord methodsFor: 'comparing' stamp: 'mp 5/18/2010 11:59'!
hash

	^ (self methodReference hash bitXor: self receiver hash) bitXor: self arguments hash! !

!SReplayRecord methodsFor: 'initialize-release' stamp: 'mp 5/18/2010 11:23'!
initialize

	self arguments: #().! !

!SReplayRecord methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:55'!
methodReference
	"Answer the value of methodReference"

	^ methodReference! !

!SReplayRecord methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:55'!
methodReference: anObject
	"Set the value of methodReference"

	methodReference := anObject! !

!SReplayRecord methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:23'!
receiver
	"Answer the value of receiver"

	^ receiver! !

!SReplayRecord methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:23'!
receiver: anObject
	"Set the value of receiver"

	receiver := anObject! !

!SReplayRecord methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:23'!
recordedResult
	"Answer the value of recordedResult"

	^ recordedResult! !

!SReplayRecord methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:23'!
recordedResult: anObject
	"Set the value of recordedResult"

	recordedResult := anObject! !

STracer subclass: #SStateViewTracer
	instanceVariableNames: 'observedClass instVarName valueDict gatheredValues'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Spike-StateView'!

!SStateViewTracer class methodsFor: 'instance creation' stamp: 'mp 1/24/2011 17:07:53.882'!
onClass: aClass instVarName: aSymbol
	^ (super 
		on: SProject current 
		entryPoints: (SProject current allTestsAsEntryPoints))
		observedClass: aClass;
		instVarName: aSymbol;
		yourself! !

!SStateViewTracer methodsFor: 'wrapper events' stamp: 'mp 9/29/2010 22:41:40.35'!
addValue: anObject

	self gatheredValues add: anObject.! !

!SStateViewTracer methodsFor: 'running' stamp: 'mp 9/29/2010 22:45:30.73'!
endExecutionOf: anEntryPoint withResult: anObject

	self gatheredValues ifNotEmpty: [
		self valueDict 
			at: anEntryPoint
			put: self gatheredValues].
	self reset.! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 22:39:10.161'!
gatheredValues
	"Answer the value of gatheredValues"

	^ gatheredValues! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 22:39:10.166'!
gatheredValues: anObject
	"Set the value of gatheredValues"

	gatheredValues := anObject! !

!SStateViewTracer methodsFor: 'wrapper instrumentation' stamp: 'mp 9/29/2010 22:52:01.306'!
getWrapperClass

	^ SStateWrapper! !

!SStateViewTracer methodsFor: 'wrapper instrumentation' stamp: 'mp 9/29/2010 22:23:25.775'!
getWrapperOn: aSelector inClass: aClass
	((aClass whichSelectorsAccess: self instVarName) includes: aSelector)
		ifTrue: [	^ self getWrapperClass on: aSelector inClass: aClass with: self]
		ifFalse: [^ nil]! !

!SStateViewTracer methodsFor: 'initialize-release' stamp: 'mp 9/29/2010 22:39:31.28'!
initialize
	super initialize.
	self valueDict: Dictionary new.
	self gatheredValues: OrderedCollection new.! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 22:22:25.497'!
instVarName
	"Answer the value of instVarName"

	^ instVarName! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 22:22:25.501'!
instVarName: anObject
	"Set the value of instVarName"

	instVarName := anObject! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 21:52:26.809'!
observedClass
	"Answer the value of observedClass"

	^ observedClass! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 21:52:26.814'!
observedClass: anObject
	"Set the value of observedClass"

	observedClass := anObject! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 22:39:47.398'!
reset

	self gatheredValues: OrderedCollection new.! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 21:58:58.701'!
selectedClasses

	^ {self observedClass}! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 22:27:24.472'!
valueDict
	"Answer the value of valueDict"

	^ valueDict! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 22:27:24.476'!
valueDict: anObject
	"Set the value of valueDict"

	valueDict := anObject! !

!SStateViewTracer methodsFor: 'public api' stamp: 'mp 9/30/2010 10:46:18.705'!
valuesAsSet
	| resultSet |
	resultSet := Set new.
	self valueDict valuesDo: [:coll | 
		coll do: [:each | resultSet add: each]].
	^ resultSet sorted! !

SWrapper subclass: #SStateWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Spike-StateView'!

!SStateWrapper methodsFor: 'evaluating' stamp: 'mp 9/30/2010 10:41:22.998'!
valueWithReceiver: anObject arguments: anArrayOfObjects
	"This is the general case where you want both a before and after method, but if you
	want just a before method, you might want to override this method for optimization."
	| value |
	self beforeMethod.
	^ [
		self clientMethod valueWithReceiver: anObject arguments: anArrayOfObjects.
	] ensure: [self afterMethod.
			value := anObject instVarNamed: self tracer instVarName.
			value isLiteral
				ifTrue: [self tracer addValue: value copy]
				ifFalse: [self tracer addValue: value asString]]! !
